
MAP               equ   49152
BACKBUFFER        equ   49152-6144

MAX_ENERGY        equ   20*8
MAX_TIME          equ   20*8

OFS_X             equ   0
OFS_Y             equ   1
OFS_HEIGHT        equ   2
OFS_FALLHEIGHT    equ   3
OFS_MOVEFLAGS     equ   4
OFS_PATHTYPE      equ   5
OFS_SPEEDCOUNT    equ   6
OFS_SPEED         equ   7
OFS_SIZE          equ   8

MAX_OBJECTS       equ   100


; OFS_PATHTYPE equates:
PATH_NORMAL       equ   0
PATH_PERIMETER_L  equ   1
PATH_PERIMETER_R  equ   2
PATH_DEFLECTOR    equ   3



; bits per block in map
; 0-2 = height of this block (0 = no block)
; 3 = set if not solid (only block at height specified)
; 4 = special object type
; 5 = object to collect
; 6+7 = code for anything also in this block location

; 6+7 equates:
OBJECT_PLAYER     equ   64    ; player
OBJECT_ROBOT      equ   128   ; enemy robot


; if bit 5 set, collection object type is in bits 0+1
OBJECT_ENERGY     equ   32+0
OBJECT_HYDROGEN   equ   32+1
OBJECT_TIME       equ   32+2

; if bit 4 set, special object type is in bits 5-7
SPECIAL_MASK      equ   %11110000
SPECIAL_PUSH      equ   16+%00000000      ; this block also has bits 0-2 as solid block height



