
Render_HUD:       ld    de,20480+(2*32)
                  ld    ix,HUD_Table      ; line 18

r_hud_loop:       ld    a,(ix+0)
                  inc   ix

                  ld    h,0
                  ld    l,a
                  add   hl,hl
                  add   hl,hl
                  add   hl,hl

                  cp    32
                  jr    nc,r_hud_ascii

                  ld    b,0
                  ld    c,a
                  add   hl,bc
                  ld    bc,HUD_Gfx
                  add   hl,bc
                  ld    a,(hl)
                  inc   hl
                  jr    r_hud_renderchar

r_hud_ascii:      ld    bc,GameFont-256
                  add   hl,bc
                  ld    a,%00010111

r_hud_renderchar: ex    af,af'
                  ex    de,hl
                  push  hl

                  ld    b,8
r_hud_renderbits: ld    a,(de)
                  ld    (hl),a
                  inc   de
                  inc   h
                  djnz  r_hud_renderbits

                  dec   h
                  call  Scr2Attr
                  ex    af,af'
                  ld    (hl),a

                  pop   hl
                  ex    de,hl

r_hud_next:       inc   e
                  jr    nz,r_hud_loop
                  ret

                ; 6 lines of display here
HUD_Table:
                  db    000,001,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,005,016,005,005,005,002,000
                  db    000,007,"L","I","F","E"," ",000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,015,000,000,000,008,000
                  db    000,007,"T","I","M","E"," ",000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,015,000,000,000,008,000
                  db    000,007,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,015,009,010,011,008,000
                  db    000,007,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,000,015,012,013,014,008,000
                  db    000,003,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,006,017,006,006,006,004,000


HUD_Gfx:          db    %00001000         ; attr
                  db    0,0,0,0,0,0,0,0   ; 8 x display bytes

                  db    8+2               ; 1
                  db    %00000011
                  db    %00000111
                  db    %00001111
                  db    %00011111
                  db    %00111111
                  db    %01111111
                  db    %11111110
                  db    %11111100

                  db    8+2               ; 2
                  db    %11000000
                  db    %11100000
                  db    %11110000
                  db    %11111000
                  db    %11111100
                  db    %11111110
                  db    %01111111
                  db    %00111111

                  db    8+2               ; 3
                  db    %11111100
                  db    %11111110
                  db    %01111111
                  db    %00111111
                  db    %00011111
                  db    %00001111
                  db    %00000111
                  db    %00000011

                  db    8+2               ; 4
                  db    %00111111
                  db    %01111111
                  db    %11111110
                  db    %11111100
                  db    %11111000
                  db    %11110000
                  db    %11100000
                  db    %11000000

                  db    8+4               ; 5
                  db    %01010101
                  db    %11111111
                  db    %01101101
                  db    %10110110
                  db    %11111111
                  db    %10101010
                  db    %00000000
                  db    %00000000

                  db    8+4               ; 6
                  db    %00000000
                  db    %00000000
                  db    %10101010
                  db    %11111111
                  db    %10110110
                  db    %01101101
                  db    %11111111
                  db    %01010101

                  db    8+4               ; 7
                  db    %01011100
                  db    %11101000
                  db    %01111100
                  db    %11011000
                  db    %01101100
                  db    %11111000
                  db    %01011100
                  db    %11101000

                  db    8+4               ; 8
                  db    %00111010
                  db    %00010111
                  db    %00111110
                  db    %00011011
                  db    %00110110
                  db    %00011111
                  db    %00111010
                  db    %00010111

                  db    8+7               ; 9 = arrow T1
                  db    %00000000
                  db    %01111111
                  db    %01111111
                  db    %01111110
                  db    %01111111
                  db    %01111111
                  db    %01110111
                  db    %01100001

                  db    8+7               ; 10 = arrow T2
                  db    %00000000
                  db    %10000000
                  db    %10000000
                  db    %00000000
                  db    %10000000
                  db    %11100000
                  db    %11111000
                  db    %11111110

                  db    8+7               ; 11 = arrow T3
                  db    0,0,0,0,0,0,0,0

                  db    8+7               ; 12 = arrow B1
                  db    %00000000,0,0,0,0,0,0,0

                  db    8+7               ; 13 = arrow B2
                  db    %01111111
                  db    %00011111
                  db    %00000111
                  db    %00000001
                  db    %00000000
                  db    %00000000
                  db    %00000000
                  db    %00000000

                  db    8+7               ; 14 = arrow B3
                  db    %10000000
                  db    %11100000
                  db    %11111000
                  db    %11111110
                  db    %01111110
                  db    %00011110
                  db    %00000000
                  db    %00000000

                  db    8+4               ; 15
                  db    %00111100
                  db    %01101110
                  db    %00110100
                  db    %01111110
                  db    %00111100
                  db    %01110110
                  db    %00101100
                  db    %01111110

                  db    8+2               ; 16
                  db    %11011011
                  db    %11111111
                  db    %01011010
                  db    %11111111
                  db    %11111111
                  db    %11011011
                  db    %00111100
                  db    %00111100

                  db    8+2               ; 17
                  db    %00111100
                  db    %00111100
                  db    %11011011
                  db    %11111111
                  db    %11111111
                  db    %01011010
                  db    %11111111
                  db    %11011011









