
CompressMap:      ld    hl,49152
                  ld    de,25088

comp_loop:        ld    a,(hl)
                  cp    255
                  jr    z,comp_match

                  inc   hl
                  cp    (hl)
                  dec   hl
                  jr    z,comp_match

comp_storebyte:   ld    (de),a
                  inc   de
                  inc   hl

comp_next:        ld    a,h
                  or    a
                  jr    nz,comp_loop

                ; DE = (last byte + 1) written with compressed data
                  ex    de,hl
                  ld    bc,25088
                  or    a
                  sbc   hl,bc
                  ld    b,h
                  ld    c,l         ; return length of compressed data in BC
                  ret

comp_match:       push  hl
                  ld    b,a

                  ld    c,1
comp_repeatcnt:   inc   hl
                  cp    (hl)
                  jr    nz,comp_repeatexit

                  inc   c
                  jr    nz,comp_repeatcnt

comp_repeatexit:  cp    255
                  jr    z,comp_storerepeat      ; 255 always stored as a sequence

                  ld    a,c
                  or    a
                  jr    z,comp_storerepeat
                  cp    4
                  jr    nc,comp_storerepeat

                  pop   hl
                  ld    a,b
                  jr    comp_storebyte

comp_storerepeat: inc   sp          ; drop PUSHed HL map pointer
                  inc   sp

                  ex    de,hl
                  ld    (hl),255    ; signals repeating bytes sequence
                  inc   hl
                  ld    (hl),b      ; repeating byte value
                  inc   hl
                  ld    (hl),c      ; repetitions of this byte
                  inc   hl
                  ex    de,hl

                  jr    comp_next



DecompressMap:    ld    hl,49152
                  ld    de,25088

decomp_loop:      ld    a,h
                  or    a
                  ret   z

                  ld    a,(de)
                  inc   de
                  cp    255
                  jr    z,decomp_repeat

                  ld    (hl),a
                  inc   hl
                  jr    decomp_loop

decomp_repeat:    ex    de,hl
                  ld    a,(hl)      ; repeating byte value
                  inc   hl
                  ld    b,(hl)      ; repeating byte count
                  inc   hl
                  ex    de,hl

decomp_storereps: ld    (hl),a
                  inc   hl
                  djnz  decomp_storereps

                  jr    decomp_loop



