
Init_Effects:     call  Init_Robot_Gate
                  ret

Do_Effects:       call  Do_Robot_Gate
                  ret


Init_Robot_Gate:  ld    hl,57214
                  ld    (robotgate),hl
                  ld    (hl),8+1          ; 1 high + non-solid column
                  inc   l
                  ld    (hl),8+1
                  inc   l
                  ld    (hl),8+1
                  inc   l
                  ld    (hl),8+1

                  ld    hl,55422
                  ld    (hl),8+1          ; 1 high + non-solid column
                  inc   l
                  ld    (hl),8+1
                  inc   l
                  ld    (hl),8+1
                  inc   l
                  ld    (hl),8+1

                  xor   a
                  ld    (robotgatedir),a
                  ld    a,160
                  ld    (robotgatespeed),a
                  ret

Do_Robot_Gate:    ld    hl,robotgatespeed
                  dec   (hl)
                  ret   nz
                  ld    (hl),8            ; default next delay

                  ld    de,(robotgate)

                  ld    a,(de)
                  and   %11110000
                  ret   nz                ; something is on or under this block
                  inc   e
                  ld    a,(de)
                  and   %11110000
                  ret   nz
                  inc   e
                  ld    a,(de)
                  and   %11110000
                  ret   nz
                  inc   e
                  ld    a,(de)
                  and   %11110000
                  ret   nz

                  ld    a,(robotgatedir)
                  or    a
                  jr    z,robot_gate_up

robot_gate_down:  ld    a,(de)
                  dec   a
                  ld    (de),a
                  dec   e
                  ld    (de),a
                  dec   e
                  ld    (de),a
                  dec   e
                  ld    (de),a

                  cp    8+1               ; = min height ?
                  ret   nz                ; not reached min gate height

                  ld    (hl),64           ; delay for next gate movement

                  ld    hl,(robotgate)
                  ld    de,57214
                  or    a
                  sbc   hl,de
                  jr    nz,robot_next_gate

                  ld    de,55422

robot_next_gate:  ld    (robotgate),de

                  xor   a
                  ld    (robotgatedir),a  ; gate up
                  ret

robot_gate_up:    ld    a,(de)
                  inc   a
                  ld    (de),a
                  dec   e
                  ld    (de),a
                  dec   e
                  ld    (de),a
                  dec   e
                  ld    (de),a

                  cp    8+3
                  ret   c                 ; not reached max gate height

                  ld    (hl),32           ; delay for gate at max height
                  ld    (robotgatedir),a  ; A != 0 = gate down
                  ret


robotgate:        dw    0
robotgatespeed:   db    0
robotgatedir:     db    0





