
                  org   49152
                  jp    Save_Game

                  ld    hl,32768
                  ld    de,32769
                  ld    bc,16383
                  ld    (hl),0
                  ldir
                  ret

Save_Game:
                ; find length of code section
                  ld    hl,49152
                  xor   a
Find_Last_Byte:   dec   hl
                  cp    (hl)
                  jr    z,Find_Last_Byte

                  inc   hl
                  ld    bc,25088
                  or    a
                  sbc   hl,bc
                  ld    (code_length),hl  ; length of code block


                ; save BASIC program
                  ld    ix,BasicHeader
                  ld    de,17
                  xor   a
                  call  Save_Block

                  ld    ix,BasicProgram
                  ld    de,EndBasic-BasicProgram
                  ld    a,255
                  call  Save_Block

                ; save CODE
                  ld    ix,CodeHeader
                  ld    de,17
                  xor   a
                  call  Save_Block

                  ld    ix,25088
                  ld    de,(code_length)
                  ld    a,255
                  call  Save_Block
                  ret


Save_Block:       call  1218
                  call  waitsecond
                  ret

waitsecond:       push  hl
                  push  bc
                  ld    hl,1045
secdelay:         djnz  secdelay
                  dec   hl
                  ld    a,h
                  or    l
                  jr    nz,secdelay
                  pop   bc
                  pop   hl
                  ret


BasicHeader:      db    0                       ; program
                  db    "BoomBot!  "            ; enter game name here (10 chars)
                  dw    EndBasic-BasicProgram   ; length of basic block
                  dw    0                       ; auto-line
                  dw    EndBasic-BasicProgram   ; no vars, so = length of basic block

CodeHeader:       db    3                       ; code
                  db    "boomcode  "            ; enter game name here (10 chars)
code_length:      dw    0                       ; length of code block
                  dw    25088                   ; start of code block
                  dw    32768                   ; unused for code



CODE              equ   175
USR               equ   192
INK               equ   217
PAPER             equ   218
BORDER            equ   231
LOAD              equ   239
LET               equ   241
POKE              equ   244
PRINT             equ   245
PEEK              equ   190
REM               equ   234
GOTO              equ   236
LIST              equ   240
PAUSE             equ   242
RANDOMIZE         equ   249
CLEAR             equ   253

NUM               macro ascii,real
                  db    ascii
                  db    14
                  db    0,0
                  dw    real
                  db    0
                  endm

BasicProgram:     db    0,0              ; line num, HB/LB order
                  dw    Line0Len         ; line length inc. newline char
                  Line0:

                  db    22,0,0,16,7,17,7,6,6,6,6,6,6,6,6

                  db    BORDER
                  NUM   "5", 0
                  db    ":"
                  db    PAPER
                  NUM   "5", 0
                  db    ":"
                  db    INK
                  NUM   "5", 0
                  db    ":"
                  db    CLEAR
                  NUM   "65535", 25087
                  db    ":"
                  db    LOAD, 34, 34, CODE
                  db    ":"
                  db    RANDOMIZE, USR
                  NUM   "25088", 32768

                  db    $0D   ; newline
                  Line0Len   equ   $-Line0

                  db    0,20              ; line num, HB/LB order
                  dw    65280             ; line length inc. newline char

EndBasic:       ; marks end of BASIC loader program





