C_SINGLE        equ     1
C_DOUBLE        equ     2
C_INK           equ     16
C_PAPER         equ     17
C_AT            equ     22

textposn        dw      0
textattr        db      0
textdouble      db      0

WriteText:      ld      a,(de)
                inc     de
                cp      32
                jr      c,ctrlchar

                call    WriteChar
                jp      WriteText

ctrlchar:       or      a
                ret     z
                cp      C_SINGLE
                jr      z,singleheight
                cp      C_DOUBLE
                jr      z,doubleheight
                cp      C_INK
                jr      z,newink
                cp      C_PAPER
                jr      z,newpaper
                cp      C_AT
                jr      z,newposn
                cp      8
                jp      z,move_cursor_right
                jp      WriteText

move_cursor_right:
                call    cursor_right
                jp      WriteText

singleheight:   xor     a
                jr      settextheight

doubleheight:   ld      a,1

settextheight:  ld      (textdouble),a
                jp      WriteText

newink:         ld      a,(de)
                inc     de
                and     7
                ld      c,a
                ld      a,(textattr)
                and     248
                or      c
                ld      (textattr),a
                jp      WriteText

newpaper:       ld      a,(de)
                inc     de
                rla
                rla
                rla
                and     %00111000
                ld      c,a
                ld      a,(textattr)
                and     %11000111
                or      c
                ld      (textattr),a
                jp      WriteText

newposn:        ld      a,(de)
                inc     de
                ld      h,a
                ld      a,(de)
                inc     de
                ld      l,a
                ld      (textposn),hl
                jp      WriteText


WriteChar:      push    de
                ld      h,0
                ld      l,a
                add     hl,hl
                add     hl,hl
                add     hl,hl
                ld      de,GameFont-256
                add     hl,de
                ex      de,hl

                ld      hl,(textposn)
                ld      a,h
                add     a,a
                add     a,a
                add     a,a
                ld      h,a
                call    MapScreenAddress

                push    hl
                ld      b,8

                ld      a,(textdouble)
                or      a
                jr      nz,writedouble

writenormal:    ld      a,(de)
                ld      (hl),a
                inc     de
                inc     h
                djnz    writenormal

                pop     hl
                call    Scr2Attr
                ld      a,(textattr)
                ld      (hl),a

                ld      bc,#0118
                pop     de
                jr      cursor_right

writedouble:    ld      a,(de)
                ld      (hl),a
                inc     h
                ld      (hl),a
                inc     de
                call    pixeldown
                djnz    writedouble

                pop     hl
                call    Scr2Attr
                ld      a,(textattr)
                ld      (hl),a
                ld      bc,32
                add     hl,bc
                ld      (hl),a

                ld      bc,#0217
                pop     de

cursor_right:   ld      hl,(textposn)
                inc     l
                ld      a,l
                and     31
                jr      nz,writeexit
                ld      l,a
                ld      a,h
                add     a,b
                ld      h,a
                cp      c
                jr      c,writeexit
                ld      h,0

writeexit:      ld      (textposn),hl
                ret


; A = value, DE = text ptr
ByteToString:   ld    h,0
                ld    l,a
                jr    dobytetostring

; A = value, DE = text ptr; only for 2 decimal digits
ByteToString2:  ld    h,0
                ld    l,a
                jr    dobytetostring2


; HL = value, DE = text ptr
WordToString:   ld      bc,-10000
                call    getdigit
                ld      bc,-1000
                call    getdigit
dobytetostring: ld      bc,-100
                call    getdigit
dobytetostring2:ld      bc,-10
                call    getdigit
                ld      a,"0"
                add     a,l
                ld      (de),a
                ret

getdigit:       ld      a,"0"-1
getdig1:        inc     a
                add     hl,bc
                jr      c,getdig1
                sbc     hl,bc
                ld      (de),a
                inc     de
                ret

GameFont:       incbin  "Game.font"


